{$A+,B-,D+,E+,F+,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T+,V-,X+,Y+}
{$M 32768,0,655360}
 PROGRAM Tree_View;
 USES CrtPlus, Dos, TObjects, DosPlus, Convert;

 { CE PROGRAMME FONCTIONNE CORRECTEMENT S'IL NE RENCONTRE PAS D'ENTREES
   REPERTORIELLES ERRONEES, SI C'EST LE CAS, LA STRUCTURE PEUT AVOIR
   DES ERREURS DANS DESCENDANT/ANCETRE

   Dernre MAJ : 28/8/00 }

 TYPE PTree = ^TTree;
      TTree = RECORD
            Elem : STRING[12];
            Ancetre, Descendant : PTree;
            Suivant, Precedent  : PTree;
            {Remarques : * L'anctre pointe sur le -premier- descendant
                         * -Chaque- descendant pointe sur son anctre}
      END;

 VAR Tree : PTree;
     Liste : ^TListe;
     StartTime, EndTime : SysTimeRec;

 PROCEDURE NewBranch(Anc : PTree; S : STRING); {Ajoute une branche
                                               puis pointe sur elle}
 VAR Nouveau : PTree;
 BEGIN
      New(Nouveau);
      IF Tree <> NIL THEN BEGIN
         WHILE Tree^.Suivant <> NIL DO Tree:= Tree^.Suivant; {Pointe sur
                                              l'avant dernier}
         Tree^.Suivant:= Nouveau;
         Nouveau^.Elem:= S;
         Nouveau^.Precedent:= Tree; {Pour lier le dernier avec l'avant dernier}
         Nouveau^.Suivant:= NIL;    {Et crer le suivant}
         Nouveau^.Descendant:= NIL; {Pas de descendants pour l'instant}
         Nouveau^.Ancetre:= Anc;    {Rfrence  l'anctre}
         Tree:= Tree^.Suivant; {Maintenant, il faut pointer sur le
                               dernier, pour pouvoir crer la sous-branche
                               sous lui et non sous l'avant dernier !}
      END ELSE BEGIN {Ici c'est clair}
         Tree:= Nouveau;
         Tree^.Elem:= S;
         Tree^.Suivant:= NIL;
         Tree^.Ancetre:= Anc;
         Tree^.Precedent:= NIL;
         Tree^.Descendant:= NIL;
      END;
 END;

 PROCEDURE TopOfTree; {Rejoint la racine}
 BEGIN
      WHILE Tree^.Ancetre <> NIL DO Tree:= Tree^.Ancetre;
 END;

 VAR Col : BYTE;
     I    : BYTE;

 PROCEDURE BuildTree(Chemin : STRING); {Construit l'arbre. Ici avec la
                                        structure arborescente du lecteur C}
 VAR R : SearchRec; Anc : PTree;
 BEGIN
      TColor(14,0); TMkSpace(1,80,6); TWrite(Chemin,6,2);
      IF Chemin[Length(Chemin)] <> '\' THEN Chemin:= Chemin+'\';
      FindFirst(Chemin+'*.*', Directory, R);
      WHILE DosError = 0 DO BEGIN

            IF (R.Attr AND Directory <> 0) THEN IF (R.Name <> '.') AND (R.Name <> '..') THEN BEGIN
               Chemin:= Chemin + R.Name + '\';

               Anc:= Tree; {On sauvegarge l'anctre ici.
                    NOTE : L'anctre ne pointe pas encore sur le descendant}

               Tree:= Tree^.Descendant; {Vers le descendant}

               NewBranch(Anc, R.Name); {On cre la branche si elle n'existe
                                      pas ou on rejoint sa queue pour ajouter
                                      un nouvel lment}
               IF Tree^.Ancetre^.Descendant = NIL THEN
               Tree^.Ancetre^.Descendant:= Tree; {Une fois que le premier
                                                 descendant a t cr,
                                                 l'anctre doit pointer sur
                                                 lui}
               BuildTree(Chemin); {Recursivit finie}
            END;

            IF DosError = 18 THEN BEGIN
               Chemin:= Copy(Chemin,1,Length(Chemin)-Length(R.Name)-1);
               IF Tree^.Ancetre <> NIL THEN Tree:= Tree^.Ancetre;
               {Revenir vers l'anctre}
            END;

            FindNext(R);
      END;
 END;

 PROCEDURE ViewTree(S : STRING); {Juste pour parcourir l'arbre. Ex : rechercher un element
                                 Lie les differents elements entre eux par des
                                 traits hirarchiques
                                 !S doit tre vide!}
 VAR Prec : PTree;
     I    : BYTE;
     TempStr : STRING;
 BEGIN
      WHILE Tree <> NIL DO BEGIN
            IF Tree^.Ancetre = NIL THEN Liste^.NewItem(' '+Tree^.Elem) ELSE

             IF Tree^.Descendant <> NIL THEN BEGIN

                IF Tree^.Suivant <> NIL THEN
                   Liste^.NewItem(S+'  '+Tree^.Elem) ELSE BEGIN
                         TempStr:= S+' '+Tree^.Elem+' ';
                         FOR I:= Length(TempStr) TO 61 DO TempStr:= TempStr+#196;
                         TempStr:= TempStr+' '+#8#9+' '+Tree^.Ancetre^.Elem;
                         Liste^.NewItem(TempStr);
                   END;

             END ELSE BEGIN
                 IF Tree^.Suivant <> NIL THEN
                   Liste^.NewItem(S+' '+Tree^.Elem) ELSE BEGIN

                         TempStr:= S+' '+Tree^.Elem+' ';
                         FOR I:= Length(TempStr) TO 61 DO TempStr:= TempStr+#196;
                         TempStr:= TempStr+' '+#8#9+' '+Tree^.Ancetre^.Elem;
                         Liste^.NewItem(TempStr);
                   END;
             END;

            IF Tree^.Descendant <> NIL THEN BEGIN
               FOR I:= Length(S) TO Col DO S:= S+' ';
               IF Tree^.Suivant <> NIL THEN S[Length(S)-4]:= '';
               Prec:= Tree;
               Tree:= Tree^.Descendant;
               Col:= Col+5;
               ViewTree(S);
            END;
            IF Tree = NIL THEN BEGIN
               Tree:= Prec;
               Col:= Col-5;
               S:= Copy(S,1,Col-5+1);
            END;
            Tree:= Tree^.Suivant;
      END;
 END;

 PROCEDURE Presentation;
 BEGIN
      IF GetVideoMode <> 3 THEN SetTextMode(3);
      TColor(7,0); Clear; SetCursorPos(24,1); ShowCursor;
      TDrawBox(1,1,4,80, 7,0, Off, Single);
      TCenter('DIRECTORY LIST VERSION 2.0',2);
      TCenter('Sad LANKRI. 31 mai 2000',3);
 END;

 VAR S : STRING;

 BEGIN
      SetCharWidth(8);
      Presentation;
      SetIntensity(High);
      TWrite('Exploration de la structure. Attendez ...',5,1);

      New(Tree); Tree:= NIL;

      GetDir(0,S);
      IF ParamCount <> 0 THEN NewBranch(NIL, UpCaseStr(ParamStr(1))) ELSE NewBranch(NIL, S);
      New(Liste);
      WITH Liste^ DO BEGIN
           Init(6,1,23,80);
           WITH Palette DO BEGIN
                Selected.X:= 15; Selected.Y:= 9;
                Unselected.X:= 15; Unselected.Y:= 0;
                Implicite.X:= 14; Implicite.Y:= 3;
           END;
      END;

      GetTime(StartTime);
      IF ParamCount <> 0 THEN BuildTree(UpCaseStr(ParamStr(1))) ELSE BuildTree(S); {Construit}
      GetTime(EndTime);

      TColor(10,0);
      TWrite('Recherche dmarre  '+Num2Str(StartTime.Hour)+':'+Num2Str(StartTime.Min)+':'
        +Num2Str(StartTime.Sec)+':'+Num2Str(StartTime.Sec100)+ ' et termine  '+

         Num2Str(EndTime.Hour)+':'+Num2Str(EndTime.Min)+':'
        +Num2Str(EndTime.Sec)+':'+Num2Str(EndTime.Sec100)

        ,25,1);

      TMkSpace(1,80,5);
      Col:= 0;

      TopOfTree;
      ViewTree('');

      HideCursor;
      Liste^.Run;
      Liste^.Done; {Liste}
      Dispose(Liste);

      ClearKbdBuf;
      SetCharWidth(9); TColor(7,0); Clear; SetCursorSize(15,16);
 END.